#include <getopt.h>
#include <QApplication>
#include <QIcon>

#include "para_windows.h"
#include "config.h"

static const struct option long_options[] = {
  {"help",    0, 0, 'h'},
  {"version", 0, 0, 'v'},
  {0,0,0,0}
};
static const char short_options[] = "hv";

void usage(void)
{
  fprintf(stderr, paraHelp);
}

int main(int argc,char **argv)
{
  int c;
  QApplication app(argc, argv);
  ParaWindows windows; 
   
  while ((c = getopt_long(argc, argv, short_options, long_options, NULL))
          != -1) {
    switch (c) {
      case 'h':
        usage();
        exit(0);
      case 'v':
        fprintf(stderr, paraVersion);
        exit(0);
      default:
        usage();
        exit(127);
    }
  }
  if (argc > 1) {
    usage();
    exit(127);
  }
  
  Q_INIT_RESOURCE(paramon);
  app.setWindowIcon(QIcon(":/paramon-logo"));
  windows.windowsDisplay();
  
  return app.exec();
}
