#ifndef PARA_FREE_METRIC_H
#define PARA_FREE_METRIC_H

#include <stdio.h>
#include <sys/sysinfo.h>
#include <linux/limits.h>
#include <string.h>
#include <unistd.h>
#include <stdint.h>

#include "para_res.h"

#define CPUINFO  "/proc/stat"
#define MEMINFO  "/proc/meminfo"
#define DISKINFO "/proc/diskstats"
#define NETINFO  "/proc/net/dev"


class ParaFreeMetricMon
{
 public:
  ParaFreeMetricMon();
  ~ParaFreeMetricMon();
  
  void collector();
  void titlePrint();
  void valuePrint();
  ParaDeviceArray* getDevice(int d);
 
 private:
  void init();
  void error();
  int isDiskMonitored(int major,char *name);
  int isNetMonitored(char *name);

  ParaDeviceArray mem,cpu,disk,net;
  int64_t *lastUser,*lastNice,*lastSys,*lastIdle,*lastIowait,
      *lastHardirq,*lastSoftirq,*lastTotal;
  int64_t *lastRsect,*lastWsect;
  int64_t *lastBytesOut,*lastBytesIn;
};

#endif
