#ifndef PARA_GRAPH_H
#define PARA_GRAPH_H

#include <QWidget>
#include <QPainter>
#include <QKeyEvent>

#include "para_host_window.h"

class ParaGraph:public QWidget
{
  Q_OBJECT
 public:
  ParaGraph();
  ParaGraph(QWidget*);
  ~ParaGraph();
  
  void setHost();
  void setRealModelInit(int n);               // initialize the window display
  QSizeF getCurSize();
  float getRatio();
  void setRatio(float,float);
  void setFontRatio(float);                   // set the font's size in different resolutions
  float getX();                               // get the x coordinate of the window's edge
  float getY();                               // get the y coordinate of the window's edge
  QColor getColor(PARA_WINDOW_AREA);
  void setRateMax(float data){this->rateMax = data;}
  void setDiskMax(float data){this->diskMax = data;}
  void setNetMax(float data){this->netMax = data;}
 public slots:
  void realModel(float *display);

 protected:
  void paintEvent(QPaintEvent*);
  void resizeEvent(QResizeEvent*);
  void keyPressEvent(QKeyEvent*);
 
 private:
  ParaHostScale *hostScale;
  ParaHostWindow *hostWindow;
  bool helpStatus;
  int nDisplay;
  float ratio;
  float x,y;
  QSizeF curSize;
  float rateMax,diskMax,netMax; // memory, swap and cpu are all percent values except for disk and net both absolute values
};
#endif
