#include "para_graph_res.h"

ParaHostScale::ParaHostScale()
{
  initHostScale();
}

ParaHostScale::~ParaHostScale()
{
}

void ParaHostScale::setOrigPoint(int x,int y)
{
  orig.setXY(x,y);
}

void ParaHostScale::setOrigPoint(ParaPoint &point)
{
  orig.setXY(point.getX(),point.getY());
}

ParaPoint& ParaHostScale::getBorderPoint(int point)
{
  if (0 == point)
    return borderStart;
  else
    return defPoint;
}

ParaPoint& ParaHostScale::getMemoryPoint(int point)
{
  if (0 == point)
    return memoryStart;
  else
    return defPoint;
}

ParaPoint& ParaHostScale::getSwapPoint(int point)
{
  if (0 == point)
    return swapStart;
  else
    return defPoint;
}

ParaPoint& ParaHostScale::getCpuPoint(int point)
{
  if (0 == point)
    return cpuStart;
  else
    return defPoint;
}

ParaPoint& ParaHostScale::getDiskReadPoint(int point)
{
  if (0 == point)
    return diskReadStart;
  else
    return defPoint;
}

ParaPoint& ParaHostScale::getDiskWritePoint(int point)
{
  if (0 == point)
    return diskWriteStart;
  else
    return defPoint;
}

ParaPoint& ParaHostScale::getNetOutPoint(int point)
{
  if (0 == point)
    return netOutStart;
  else
    return defPoint;
}

ParaPoint& ParaHostScale::getNetInPoint(int point)
{
  if (0 == point)
    return netInStart;
  else
    return defPoint;
}

ParaPixel& ParaHostScale::getBorderPixel(int line)
{
  if (0 == line)
    return borderArea;
  else
    return defPixel;
}

ParaPixel& ParaHostScale::getMemoryPixel(int line)
{
  if (0 == line)
    return memoryArea;
  else
    return defPixel;
}

ParaPixel& ParaHostScale::getSwapPixel(int line)
{
  if (0 == line)
    return swapArea;
  else
    return defPixel;
}

ParaPixel& ParaHostScale::getCpuPixel(int line)
{
  if (0 == line)
    return cpuArea;
  else
    return defPixel;
}

ParaPixel& ParaHostScale::getDiskReadPixel(int line)
{
  if (0 == line)
    return diskReadArea;
  else
    return defPixel;
}

ParaPixel& ParaHostScale::getDiskWritePixel(int line)
{
  if (0 == line)
    return diskWriteArea;
  else
    return defPixel;
}

ParaPixel& ParaHostScale::getNetOutPixel(int line)
{
  if (0 == line)
    return netOutArea;
  else
    return defPixel;
}

ParaPixel& ParaHostScale::getNetInPixel(int line)
{
  if (0 == line)
    return netInArea;
  else
    return defPixel;
}

void ParaHostScale::initHostScale()
{
  orig.setXY(0,0);
  
  defPoint.setXY(0,0);
  borderStart.setXY(orig.getX()+0,orig.getY()+0);
  
  memoryStart.setXY(orig.getX()+2,orig.getY()+63);
  swapStart.setXY(orig.getX()+2,orig.getY()+14);
  cpuStart.setXY(orig.getX()+24,orig.getY()+63);
  diskReadStart.setXY(orig.getX()+43,orig.getY()+66);
  diskWriteStart.setXY(orig.getX()+45,orig.getY()+66);
  netOutStart.setXY(orig.getX()+89,orig.getY()+42);
  netInStart.setXY(orig.getX()+89,orig.getY()+44);

  defPixel.setXY(0,0);
  borderArea.setXY(orig.getX()+110,orig.getY()+86);

  memoryArea.setXY(20,48);
  swapArea.setXY(20,12);
  cpuArea.setXY(63,62);
  diskReadArea.setXY(42,19);
  diskWriteArea.setXY(42,19);
  netOutArea.setXY(20,41);
  netInArea.setXY(20,41);
}
