#include "para_metric_res.h"

ParaMetric::ParaMetric()
{
  loop = true;
  initMetric();
}

ParaMetric::~ParaMetric()
{
  threadStop();
  wait();
  delete freeMetric;
}

ParaDeviceArray* ParaMetric::getDevice(int d)
{
  if (0 == d) return mem;
  else if (1 == d) return cpu;
  else if (2 == d) return disk;
  else if (3 == d) return net;
  else return NULL;
}

void ParaMetric::threadStop()
{
  loop=false;
}

void ParaMetric::run()
{
  freeMetric->collector();
  emit displayGet();

  while (loop) {
    freeMetric->collector();
    emit displayGet();
    sleep(1);
  }
}

void ParaMetric::initMetric()
{
  freeMetric = new ParaFreeMetricMon();
  mem  = freeMetric->getDevice(0);
  cpu  = freeMetric->getDevice(1);
  disk = freeMetric->getDevice(2);
  net  = freeMetric->getDevice(3);
}

