#include "para_res.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

ParaPoint::ParaPoint()
{
}

ParaPoint::~ParaPoint()
{
}

float ParaPoint::getX()
{
  return x;
}

float ParaPoint::getY()
{
  return y;
}

void ParaPoint::setX(float x)
{
  this->x = x;
}

void ParaPoint::setY(float y)
{
  this->y = y;
}

void ParaPoint::setXY(float x,float y)
{
  this->x = x;
  this->y = y;
}


// ParaDyArray
ParaDyArray::ParaDyArray()
{
  init();
}

ParaDyArray::~ParaDyArray()
{
  free(index);
  free(array);
}

void ParaDyArray::init()
{
  block = 1024;
  index = (int*)malloc(block*sizeof(int));
  array = (char*)malloc(block*sizeof(char));
  nArray = 0; used = 0;
  size = block*sizeof(char);
}

bool ParaDyArray::append(const char *tuple)
{
  int len = strlen(tuple)+1;
  char *p;
  int  *pp;

  if (len > size-used) {
    p = array;
    array = (char*)realloc(array,(size+block)*sizeof(char));
    if(NULL == array) {
      array = p;
      return false;
     }
     size += block;
  }
  if (0 == nArray%block && 0 != nArray) {
    pp = index;
    index = (int*)realloc(index,(nArray+block)*sizeof(int));
    if (NULL == index) {
      index = pp;
      return false;
    }
  }
  memcpy(array+used,tuple,len);
  index[nArray] = used;
  used += len;
  nArray += 1;
  
  return true;
}

char* ParaDyArray::getTuple(int no)
{
  char *tuple;

  if (no < 0) return NULL;
  else if (no > nArray) return NULL;
  tuple = array+index[no];
  
  return tuple;
}

int ParaDyArray::getNum()
{
  return nArray;
}

// ParaDeviceArray
ParaDeviceArray::ParaDeviceArray()
{
  sectors.resetBlock(256);
  events.resetBlock(256);
  nSectors = 0;
  nEvents = 0;
}

ParaDeviceArray::~ParaDeviceArray()
{
}

bool ParaDeviceArray::bufferInit()
{
  nSectors = sectors.getNum();
  nEvents = events.getNum();
  eventBuffer = new float*[nSectors];
  if (NULL == eventBuffer) return false;
  for (int i = 0; i < nSectors; ++i) {
    eventBuffer[i] = new float[nEvents];
    if (NULL == eventBuffer[i]) {
      for(int j = i-1; j >= 0; --j)
        delete[] eventBuffer[j];
      delete[] eventBuffer;
      return false;
    }else{
      for(int j = 0; j < nEvents; ++j){
        eventBuffer[i][j] = 0;
      }
    }
  }
  return true;
}

void ParaDeviceArray::bufferDestory()
{
  for (int i = 0; i < nSectors; ++i)
    delete[] eventBuffer[i];
  delete[] eventBuffer;
}

void ParaDeviceArray::titlePrint()
{
  printf("%s: sector[%d] event[%d]\n",device,nSectors,nEvents);
  printf("\tSECTOR:\n");
  for (int i = 0; i < nSectors; ++i) {
    printf("\t\t%s\n",sectors.getTuple(i));
  }
  printf("\tEVENT:\n");
  for (int i = 0; i < nEvents; ++i) {
    printf("\t\t%s\n",events.getTuple(i));
  }
}

void ParaDeviceArray::valuePrint()
{
  printf("%s\n",device);
  for (int i = 0; i < nSectors; ++i) {
    for(int j = 0; j < nEvents; ++j) {
      printf("%.2f ",eventBuffer[i][j]);
    }
    printf("\n");
  }
}
