#ifndef PARA_RES_H
#define PARA_RES_H

#include <string.h>

class ParaPoint
{
 public:
  ParaPoint();
  ~ParaPoint();

  float getX();
  float getY();
  void setX(float x);
  void setY(float y);
  void setXY(float x,float y);

 private:
  float x,y;
};

class ParaPixel
{
 public:
  ParaPixel(){}
  ~ParaPixel(){}
 
  float getX(){return x;}
  float getY(){return y;}
  void setX(float x){this->x=x;}
  void setY(float y){this->y=y;}
  void setXY(float x,float y){this->x=x;this->y=y;}

 private:
  float x,y;
};

class ParaDyArray
{
 public:
  ParaDyArray();
  ~ParaDyArray();
  
  void resetBlock(int block){this->block=block;}
  bool append(const char *tuple);
  char* getTuple(int no);
  int getNum();

 private:
  void init();

  int  *index;
  char *array;
  int nArray;
  int used;
  int size;
  int block;
};

class ParaDeviceArray
{
 public:
  ParaDeviceArray();
  ~ParaDeviceArray();
 
  char* getDeviceName(){return device;}
  void setDeviceName(const char *name){strcpy(device,name);}
  bool appendSector(const char *sector){return sectors.append(sector);}
  bool appendEvent(const char *event){return events.append(event);}
  void addEventVal(int s,int e,float val){eventBuffer[s][e] = val;}
  bool bufferInit();
  void bufferDestory();
  int getNSectors(){return nSectors;}
  int getNEvents(){return nEvents;}
  char* getTSectors(int s){return sectors.getTuple(s);}
  char* getTEvents(int e){return events.getTuple(e);}
  float getVEvents(int s,int e){return eventBuffer[s][e];}
  void titlePrint();
  void valuePrint();
 
 private:
  char device[256];
  int nSectors;
  ParaDyArray sectors;
  int nEvents;
  ParaDyArray events;
  float **eventBuffer;
};


#endif
